#-------------------------------------------------------------------------------
# Locale Strings in EN(English)
#
# Created By : Yogesh Kumar @ IDrive Inc
# Reviewed By: Deepak Chaurasia
#-------------------------------------------------------------------------------

package Locale;
use AppConfig;
use strict;
use warnings;

our %strings = (
#------------------------------------------------- _ -------------------------------------------------#
	'_optional_' => '[Optional]',
	'_max_1024_characters_' => '[Maximum 1024 characters]',
#------------------------------------------------- A -------------------------------------------------#
	'already_exists' => "already exists.",
	'account_with_encryption' => "account with encryption key",
	'are_using_proxy_y_n' => "Are you using Proxy (y/n)",
	'as_per_your_backup_location_your' => 'As per your Backup Location your',
	'additional_information' => "================= Additional Information =================\n",
	'archive_cleanup_operation' => "Archive Cleanup Operation",
	'archive_cleanup'   => 'Archive Cleanup',
	'archive_cleanup_title' => 'Archive Cleanup',
	'are_you_sure_to_delete_y_or_n'   => 'Are you sure to delete (y/n)?',
	'aborted'   => 'Aborted',
	'account_not_configured' => "Your account is not configured. Please configure using account_setting.pl and try again.",
	'absolute_path_required' => 'Please provide absolute path.',
	'archive_title' => 'Archive',
	'archive_running' => "Archive Cleanup job is in progress",
	'aborting_the_operation' => 'Aborting the operation.',
	'available_scripts_version_is_lower_than_current_scripts_version' => 'Available scripts version is same or lower than current scripts version. Do you really want to update (y/n)?',
#------------------------------------------------- B -------------------------------------------------#
	'backup' => 'Backup',
	'backup_job' => 'Backup job',	
	'backup_title' => 'Backup',
	'backup_location' => "BACKUP LOCATION",
	'backup_location_lc' => "Backup location",
	'bandwidth_throttle' => "Bandwidth throttle(%)",
	'backup_type' => "Backup Type",
	'backup_start_time'	=>	'Backup Start Time  : ',
	'backup_end_time'	=>	'Backup End Time : ',
	'backupset'	=>	'Backup set: ',
	'backup_type_must_be_mirror' =>	'Backup type must be "mirror" to perform archive cleanup operation.',
	#'backup_location_should_contain_only_letters_numbers_space_and_characters' => 'Reason: Backup location should contain only letters, numbers, space and characters(.-_).',
	'backup_location_should_contain_only_letters_numbers_space_and_characters' => 'Reason: Backup location should contain only letters, numbers and characters(-_).',
	'backup_location_should_be_one_to_sixty_five_characters' => "Reason: Backup location should be less than 65 characters.",
	'backup_running' => "Backup job is running",
	'backup_progress' => "Backup Progress\n===============        \n",
	'backup_in_progress' => 'Backup in progress...',
	'backup_has_been_completed' => 'Backup job is complete.',
	'backup_job_has_been_scheduled_successfully_to' => 'Backup job has been scheduled successfully',
#------------------------------------------------- C -------------------------------------------------#
	'cannot_open_directory' => "Cannot open directory",
	'cannot_fork_child' =>	'Cannot fork() child process: ',
	'checking_for_dependencies' => "Checking for package dependencies...",
	'create_new_backup_location' => "Create new Backup Location",
	'confirm_your_encryption_key' => "Confirm your encryption key",
	'could_not_complete_operation' => 'Could not complete operation. ',
	'current_loggedin_username_is' => 'Current logged in user is',
	'contact_no' => 'contact number',
	'contact_number_only_digits' => 'Contact number can have only digits',
	'contact_number_between_5_20' => 'Contact number must be between 5 to 20 characters',
	'computer_name' => 'Computer Name',
	'cannot_be_empty' => 'Cannot be empty',
	'configured_email_address_are'=> 'Configured email address(es) are ',
	'configured_email_address_is'=> 'Configured email address is',
	'couldnt_create' => 'Couldn\'t create',
	'could_not_complete_operation' => 'Could not complete operation',
	'changing_title' => 'Changing',
	'changing_service_direc_will_update_new_path' => 'Changing service directory will update the location to new path',
	'checking_for_updates' => 'Checking for new updates',
	'c_bandwidth_throttle_%' => "BANDWIDTH THROTTLE(%)",
	'configure_&_try_again' => "Please configure your account using account_setting.pl.",
	'c_restore_from' => "RESTORE FROM",
	'c_restore_location' => "RESTORE LOCATION",
	'c_retain_logs' => "RETAIN LOGS",
	'c_backup_type' => "BACKUP TYPE",
	'c_proxy_details' => "PROXY INFO ",
	'c_service_dir' => "SERVICE DIR",
	'c_email_address' => "EMAIL ADDRESS",
	'cc_file' => "File",
	'creating_user_directories'	=>	'Creating user directory...',
	'consider_def_loc_as' => 'Considering Default Restore Location as',
	'creating_restore_location' => 'Creating Restore Location',
	'checking_version_for_file' => 'Checking version(s) for the file',
	'couldnt_open' => 'Couldn\'t open',
	'could_not_find_given_file' => 'No version(s) found. Reason: File does not exist',
	'could_not_open_file' => 'Could not open file',
	'considering_default_restore_location' => "Considering Default Restore Location as ",
	'considering_default_backup_location' => 'Considering Default Backup Location as ',
	'configured_email_addresses_are'	=> 'Configured e-mail address(es) are: ',
	'creating_your_restore_location' => 'Creating your Restore location...',
	'considering_default_restore_from_location_as' => 'Considering Default Restore From Location as',
	'confirming_your_encryption_key' => "Confirming encryption key...",
	'cut_-_off' => 'Cut-off',
	'cut_-_off_time' => 'Cut-off Time',
	'calculating' => 'Calculating...',
	'can_we_upload_a_sample_file_for_speed_test_analysis' => 'Can we upload a sample file (speedTestFile.txt) for speed test analysis (y/n)?',
	'creating_the_speed_test_file_for_backup' => 'Creating speedtestfile.txt for backup...',
	'checking_network_speed_via_speedtestnet' => 'Checking network speed via speedtest.net...',
#------------------------------------------------- D -------------------------------------------------#
	'developed_by' => "Developed By:",
	'directory_does_not_exists' => 'Directory does not exists',
	'do_you_want_edit_this_y_or_n_?' => "Do you wish to modify (y/n)?",
	'do_you_want_edit_your_email_y_n' => "Do you want to edit your e-mail address (y/n)?",
	'default_encryption_key' => "Default encryption key",
	'do_you_want_view_y_or_n' => "Do you want to view the list of files to be deleted (y/n)?",
	'deleted_content' => "[Deleted Content]",
	'delaying_cleanup_operation_reason' => "Delaying cleanup operation. Reason: ",
	'deleting_files' => "Deleting files...",
	'do_you_want_to' => "Do you want to",
	'do_you_want_to_view_more_logs_yn' => 'Do you want to view more logs (y/n)?',
	'do_you_want_to_edit_any_other_files_yn' => 'Do you want to edit any other files (y/n)?',
	'display_versions_for_your_file' => 'Display versions for your file',
	'do_you_want_to_continue_yn' => 'Do you want to continue (y/n)?',
	'downloading_evs_binary' => "Checking for compatible EVS command line utility",
	'do_u_want_to_retain_logs' => "Do you want to Retain Logs (y/n)?",
	'do_u_want_to_login_as' => 'Do you want to login as ',
	'do_u_really_want_to_edit' => 'Do you really want to edit (y/n)?',
	'do_u_want_to_edit' => 'Do you wish to modify(y/n)?',
	'do_u_wish_to_continue' => 'Do you wish to continue (y/n): ',
	'dependency_unzip...' => 'unzip... ',
	'dependency_curl...' => 'curl... ',
	#'dependency_wget...' => 'wget... ',
	'does_not_have_sufficient_permissions' => 'does not have sufficient permissions',
	'does_not_exists' => 'does not exists',
	'do_you_want_to_restore_version_yn' => 'Do you want to restore any specific version (y/n)? ',
	'do_you_want_enter_mount_point' => 'Do you want to enter your mount point manually (y/n)?',
	'do_u_want_to_delete_permanently'   => 'Do you want to delete these files permanently from your account (y/n) ?',
	'delete_operation_has_been_completed'   => 'Delete operation has been completed.',
	'daily_u' => 'DAILY',
	'do_you_want_to_have_cut_off_time_for_your_backup_y_n' => 'Do you want to have cut off time for your backup (y/n)?',
	'do_you_want_to_enable_email_notification_(_y_n_)' => 'Do you want to enable email notification (y/n)',
	'do_you_want_to_disable_email_notification_(_y_n_)' => 'Do you want to disable email notification (y/n)',
	'do_you_want_to_change_email_id_(_y_n_)' => 'Do you want to change email ID (y/n)',
	'do_you_want_to_change_email_id_(_s_)_(_y_n_)' => 'Do you want to Change Email ID(s)(y/n)',
	'do_you_really_want_to_edit_(_y_n_)' => 'Do you want to edit (y/n)',
	'disable_scheduled_backup_job' => 'Disable Scheduled Backup job',
	'do_you_want_to_promt_for_restore_loc' => 'Do you want to be prompted to select restore location every time you perform restore (y/n)? ',
	'do_you_want_to_upload_multiple_chunks' => 'Do you want to upload multiple file chunks simultaneously (y/n)? ',
	'do_you_want_to_view_speed_analysis_report' => 'Do you want to view speed analysis report (y/n)?',
	'do_you_want_to_send_speed_analysis_report_to_idrive_team' => 'Do you want to send speed analysis report to IDrive support team (y/n)?',
	'deleting_speed_test_file_from_your_account' => 'Deleting speedTestFile.txt from your account...',
	'description_for_speed_test' => " \t1. Using this script, we will be calculating backup upload speed for your IDrive account.\n\t2. We will create a sample file and backup to your IDrive account and make a note of upload speed.\n\t3. Lastly we will be finding the upload speed via speedtest.net.\n\t4. Speed analysis report will be sent to IDrive support team for further observation.",
#------------------------------------------------- E -------------------------------------------------#
	'enter_your_service_path' => "Enter your service path [This location will be used to maintain the temporary data used by your scripts] [Optional]: ",
	'enter_your_new_service_path' => "Enter your new service path [This location will be used to maintain the temporary data used by your scripts] [Optional]: ",
	'enter_your' => "Enter your",
	'enter_your_restore_location_optional' => "Enter your Restore Location [Optional]",
	'enter_your_choice' => "Enter your choice: ",
	'enter_your_choice_' => "Enter your choice",
	#'enter_your_backup_location_optional' => "Enter your Backup Location [Note: Backup location should contain only letters, numbers, space and characters(.-_)] [Optional]",
	'enter_your_backup_location_optional' => "Enter your Backup Location [Note: Backup location should contain only letters, numbers and characters(-_)] [Optional]",
	'encryption_key_and_confirm_encryption_key_must_be_the_same' => "Encryption key and confirm encryption key must be the same.",
	'enter_the_encryption_key' => "Enter the encryption key",
	'enter_your_backup_location_non_dedup' => "Enter your Backup Location [Optional]",
	'enter_percentage_of_files_for_cleanup' => "Enter the percentage limit beyond which cleanup will not take place [1-100]: ",
	'end_time' => "End Time: ",
	'enter_proxy_server_ip' => "Enter Proxy Server IP",
	'enter_proxy_server_port' => "Enter Proxy Server Port",
	'enter_proxy_server_username_if_set' => "Enter Proxy Server username if set",
	'enter_proxy_server_password_if_set' => "Enter Proxy Server Password if set",
	'edit_your_account_details' => "Edit your account details",
	'exit' => "Exit",
	'email_address' => "email address",
	#'enter_your_choice' => "\nEnter your choice: ",
	'encryption_key_must_be_minimum_4_characters' => "Encryption key must contain 4 to 250 characters. Please try again",
	'encryption_key_must_be_minimum_6_characters' => "Encryption key must contain 6 to 250 characters. Please try again",
	'encryption_key_cannot_contain_blank_space' => "Encryption key cannot contain blank space.",
	'edit_proxy' => "Edit proxy details",
	'edit_service_path' => "Edit your service path",
	'enter_your_email_id' => "Enter your e-mail address [Optional]",
	'enter_your_email_id_mandatory' => "Enter your e-mail address",
	'enter_again' => 'Enter again',
	#'enter_email_addresses_with_separator' => 'Enter your e-mail ID(s) [For multiple e-mail IDs use (,) or (;) as separator]',
	'express_backup_title' => 'Express Backup',
	'enter_log_start_date__' => 'Enter start date (MM/DD/YYYY)',
	'enter_log_end_date__' => 'Enter end date (MM/DD/YYYY)',
	'enter_sno_to_view_log' => 'Enter the S.No. to view log',
	'error_in_display_log' => 'Error in display log',
	'edited_successfully' => 'Edited successfully.',
	'exclude_title' => 'Exclude',
	'edit_backup_file' => 'Edit your Backupset',
	'edit_localbackup_file' => 'Edit your Express Backupset',
	'edit_full_exclude_file' => 'Edit your Full Path Exclude List',
	'edit_partial_exclude_file' => 'Edit your Partial Path Exclude List',
	'edit_regex_exclude_file' => 'Edit your Regex Exclude List',
	'edit_restore_file' => 'Edit your Restoreset',
	'error_in_terminating' => 'Error in terminating',
	'enter_valid_location' => 'Enter valid location',
	'evs_binary_downloaded_successfully' => "Successfully downloaded compatible EVS command line utility.\n",
	'enter_bw_value' => 'Enter bandwidth throttle value [1-100]: ',
	#'enter_the_s_no_to_select_your_' => 'Enter the serial no to select your ',
	'enter_the_serial_no_to_select_your' => "Enter the S.No. to select your ",
	'exists' => 'exists',
	'enter_your_file_path' => 'Enter your file path',
	'exiting_title' => 'Exiting',
	'enter_your_restore_from_location_optional' => 'Enter your Restore From location [Optional] ',
	'enter_mount_point' => 'Enter your mount point: ',
	#'encryption_key_and_confirm_encryption_key_must_be_the_same' => "Encryption key and confirm encryption key must be the same",
	'encryption_key_is_set_successfully' => 'Encryption key is set successfully.',
	'express_backup_running' => "Express backup job is in progress.",
	'your_scheduled_job_details_are_mentioned_below' => 'Your scheduled job details are mentioned below',
	'enter_time_of_the_day_when_backup_is_supposed_to_run' => 'Enter time of the day when backup is supposed to run.',
	'enter_hour_0_-_23' => 'Enter Hour (0-23)',
	'enter_minute_0_-_59' => 'Enter Minute (0-59)',
	'enter_the_day_s_of_week_for_the_scheduled_backup_job' => 'Enter the Day(s) of Week for the Scheduled Backup Job',
	'email_notification_status' => 'Email notification status',
	'email_address_(_es_)' => 'Email address(es)',
	'enter_your_e_mail_id_(_s_)_[_for_multiple_e_mail_ids_use_(_,_)_or_(_;_)_as_separator_]' => 'Enter your e-mail ID(s) [For multiple e-mail IDs use (,) or (;) as separator]',
#------------------------------------------------- F -------------------------------------------------#
	'failed_to_create_directory' => "Failed to create directory",
	'failed_to_create_utf8_file' => "Failed to create utf8 file",
	'failed' => "Failed!!!",
	'failed_to_fetch_server_address' => "Failed to fetch server address",
	'failed_to_load_user_configuration' => "Failed to load user configuration",
	'failed_to_set_backup_location' => "Failed to set backup location.",
	'failed_to_set_restore_location' => "Failed to set restore location.",
	'failed_to_set_restore_from' => "Failed to set restore from location.",
	'failed_to_set_email_id' => "Failed to set email id.",
	'failed_to_set_retain_log' => "Failed to set retain log.",
	'failed_to_set_backup_type' => "Failed to set backup type.",
	'failed_to_install_user_files' => "Failed to install user files.",	
	'found' => 'found.',
	'file_not_found' => 'File not found',
	'file_is_empty' => 'File is empty',
	'failed_to_open_file' => "Failed to open file",
	'files_scanned' => "Files scanned:",
	'files_are_present_in_your_account' => "files are present in your account but not in your local machine. ",
	'file_is_present_in_your_account' => "file is present in your account but not in your local machine. ",
	'failure' => "Failure",
	'for_more_details_refer_the_log' => 'For more details run "logs.pl" and follow the instructions.',
	'for_linux_user_feed' => 'for Linux User Feedback',
	'failed_to_report_error' => 'Failed to report error',
	'file' => 'file',
	'from_location_is_title' => 'From Location is',
	'from_location_remains' => 'from location remains',
	'failed_to_connect' => 'Failed to connect',
	'failed_to_encode_private_key' => 'Failed to encode private key. Please try again.',
	'failed_to_clear_screen' => "Failed to Clear screen",
	'file_not_found' => 'File not found',
	'failed_to_getserver_addr' => 'Failed to get server address.',
	'failed_to_open' => 'Failed to open',
	'for_restore_version_option' => 'for restoreVersion option',
	'failed_to_update' => 'Failed to Update',
	'failed_to_set_restore_from_location' => 'Failed to set restore from location. Reason: No such file or directory.',
	'failed_to_send_mail'	=>	'Failed to send mail.',
	'for_output_parsing' => 'for Output Parsing',
	'files_considered_for_backup' =>	'Files considered for backup: ',
	'files_backed_up_now' =>	'Files backed up now: ',
	'files_already_present_in_your_account' =>	'Files already present in your account: ',
	'files_already_present_in_your_account_conditional' =>	'Files already present* in your account: ',
	'files_already_present_in_your_restore_location' => 'Files already present in your Restore Location: ',
	'files_failed_to_backup' =>	'Files failed to backup: ',
	'files_considered_for_restore' =>	'Files considered for restore: ',
	'files_restored_now' =>	'Files restored now: ',
	'files_failed_to_restore' =>	'Files failed to restore: ',
	'files_in_trash_may_get_restored_notice' => "* If files are in Trash, they may be restored directly to the account if the files match your backupset items during backup.\n These files will be included in the 'Files already present' count.",
	'failed_to_kil' =>	'Failed to kill ',
	'failed_to_lock' =>	'Failed to lock the file ',
	'frequency' => 'Frequency',
	'fri_u' => 'FRI',
#------------------------------------------------- G -------------------------------------------------#
#------------------------------------------------- H -------------------------------------------------#
	'hardware_platform' => "Hardware Platform",

#------------------------------------------------- I -------------------------------------------------#
	'idrive_maintainer' => "IDrive Inc.",
	'invalid_email_address' => 'Invalid email address(es):',
	'invalid_single_email_address' => 'Invalid email address.',
	'invalid_contact_number' => 'Invalid contact number',
	'invalid_username_pattern' => 'Invalid username',
	'invalid_choice' => 'Invalid choice.',
	'invalid_choice_please_try_again' => 'Invalid choice.Please try again.',
	'invalid_ticket_number' => 'Invalid ticket number',
	'invalid_email_addresses_are_' => 'Invalid email address(es) are: ',
	'invalid_input'    => 'Invalid Input.',
	'invalid_option' => "Invalid Option.",
	'invalid_service_directory' => "Your account is not configured. \nPlease configure your account using account_setting.pl and try again.",
	'invalid_date_or_format' => 'Invalid date or date format',
	'in_progress' => 'in progress',
	'invalid_location' => 'Invalid Location',
	'invalid_restore_loc_in_trash' => 'Invalid Restore From Location. Reason: directory exists in trash.',
	'invalid_res_loc_no_path' => 'Invalid Restore From Location. Reason: path does not exist.',
	'invalid_ip_address' => 'Invaild IP Address.',
	'invalid_port_number' => 'Invaild port number.',
	'invalid_enc_key' => 'Invalid encryption key. Please try again.',
	'is_already_logged_in_wanna_logout' => ' is already logged in. Do you want to logout (y/n)?',
	'ibackup_maintainer' => "Pro Softnet Corporation.",
	'invalid_zip_file' => 'Invalid zip file. Please download the expected zip file from the link mentioned below and try again.',
	'invalid_archive_percent' => 'Invalid value. Percentage must be between 1-100. Please try again.',
	'items_considered_for_delete' => 'Items considered for delete: ',
	'items_deletes_now' => 'Items deleted now: ', 
	'items_failed_to_delete' => 'Items failed to delete: ',
	'invalid_mount_point' => 'Invalid mount point. Please try again.',	
	'input_empty_err'	=>	'Invalid entry. Please try again: ',
	'invalid_user_pattern' => 'Invalid UserName. Please try again.',
	'invalid_password_pattern' => 'Invalid Password',
	'invalid_private_key_pattern' => 'Invalid Private Key',
	'invalid_file_path' => 'Invalid file path',
	'invalid_res_loc_edit_loc_acc_settings' => 'Invalid Restore From Location. Please Edit your Restore From Location using ___account_settings___ and try again.',,
	'invalid_version' => 'Invalid version',
	'invalid_field_type_to_validate' => "Invalid field type to validate.\n",
	'invalid_restore_location' => 'Invalid Restore Location ',
	'is_upto_date' => 'is up to date.',
	'invalid_backup_location' => 'Invalid Backup Location ',
	'invalid_entry_try_again' => 'Invalid entry. Please try again.',
	'invalid_percentage' => 'Invalid percentage.',
	'invalid_parameter' => 'Invalid parameter',
	'invalid_update_package' => 'Invalid update package.',
	'immediate_job_type' => 'Immediate',
	'if_total_files_failed_for_backup' => 'If the total files failed for backup is more than __ARG1__%, then backup will be notified as failure. ',	
#------------------------------------------------- J -------------------------------------------------#
	'job_terminated_successfully' => 'job terminated successfully',
	'job' => 'job',
	'job_name' => 'Job Name',
#------------------------------------------------- K -------------------------------------------------#
	'kindly_verify_ur_proxy' =>'Kindly verify your network connection or proxy details and try again.',
#------------------------------------------------- L -------------------------------------------------#
	'logged_in_user' => "Logged in user:",
	'linux_backup' => 'Linux Backup',
	'last_one_week' => 'Last one week',
	'last_two_weeks' => 'Last two weeks',
	'last_30_days' => 'Last 30 days',
	'log_list' => 'Log List',
	'log_displayed_successfully' => 'Log displayed successfully',
	'location_will_terminate' => 'location will terminate',
	'location' => 'location',
	'location_is_set_to' => 'Location is set to',
	'loading_your_acc_details' => 'Loading your account details',
	'login_&_try_again' => "Please login to your $AppConfig::appType account using login.pl and try again.",
	'location_press_enter_to_go_back_to_main_menu' => " location [Press enter to go back to main menu].",
	'loading_mount_points' => 'Loading information for all mount points...',
	'loading_your_account_details_please_wait' => 'Loading your account details. Please wait ...',
	'localbackup' => "Express backup",
	'localbackup_running' => "Express backup job is in progress.",
	'localbackup_not_running' => "No Express Backup job is running.",
#------------------------------------------------- M -------------------------------------------------#
	'multiple_backup_locations_are_configured' => "Multiple Backup Locations are configured with this account",
	'manual_backup' => "Manual backup",
	'manual_restore' => "Manual restore",
	'manual_localBackup' => "Manual express backup",
	'manual_archive' => "Manual archive",
	'periodic_archive' => "Periodic archive",
	'manual_backup_running' => "Manual Backup Job is running",
	'manual_localbackup_running' => "Manual Express Backup Job is running",
	'manual_scheduled_backup_jobs_running' => "Backup jobs are running",
	'manual_scheduled_backup_archive_running' => "Backup/archive Jobs are running",
	'manual_backup_not_running' => "No Backup Job is running",
	'manual_restore_not_running' => "No Restore Job is running",
	'manual_localbackup_not_running' => "No Express Backup job is running.",
	'manual_backup_set' => "Manual backupset",
	#'manual_archive_running' => "Manual archive job is running",
	'message' => 'Message',
	'machine_details' => 'Machine Details',
	'max_retry_exeeded' => 'Maximum retry exeeded',
	'menu_options_title' => 'Menu Options',
	'move_file' => 'move file',
	'mount_point_not_exist' => 'Mount point does not exist. Please try again.',
	'mount_point_doesnt_have_permission' => 'Mount point does not have sufficient permissions. Try again.',
	'max_retry'	=> 'Your Maximum retry attempts reached. Please try again.',	
	'menu_options' => 'Menu Options',
	'mon_u' => 'MON',
#------------------------------------------------- N -------------------------------------------------#
	'no_backup_or_restore_is_running' => "No Backup/Express Backup/Restore Job is running",
	'no_job_is_in_progress' => "No Job is in progress.",
	'no_logged_in_user' => "No logged in user",
	'no_such_directory_try_again' => "No such directory. Please try again.",
	'not_found' => 'Not found.',
	#'note_backup_to_device_name_should_contain_only_letters_numbers_space_&_characters' => "[Note: Backup location should contain only letters, numbers, space and characters(.-_)]",
	'note_backup_to_device_name_should_contain_only_letters_numbers_space_&_characters' => "[Note: Backup location should contain only letters, numbers and characters(-_)]",
	'no_mesasge_entered' => 'No message entered',
	'no_logs_found' => 'No logs found',
	'__note_please_press_ctrlc_exit' => 'Note: Please press CTRL+C to exit.',
	'__note_restore_loc_indiacate_restore_loc' => 'Note: Your Restore From Location should indicate the location from which you want to restore the data.',
	'no_emails_configured' => "No Email Id is configured.",
	'need_to_update_service_dir' => 'Need to update service directory.',
	'new_update_is_available' => "A new update is available, run check_for_update.pl to update to latest package.",
	'no_version_found' => 'No version found',
	'no_version_found_for_given_file' => 'No version found for given file',
	'no_such_directory' => "No such directory.",
	'new_updates_available_want_update' => 'New updates are available. Do you want to update (y/n)?',
	'__note_scheduled_backupset_considered_for_archive' => 'Note: Your scheduled backupset will be considered for archive cleanup.',
	'new_service_dir_must_not_be_sub_dir_of_old' => 'New service directory path must not be a sub directory of old.',
	'note_:_use_comma_separator_for_selecting_multiple_days_(_e_g_1_3_5_)' => 'Note: Use comma separator for selecting multiple days (E.g. 1,3,5).',
#------------------------------------------------- O -------------------------------------------------#
	'operation_aborted_due_to_percentage' => "operation aborted due to the number of files considered for deletion is <PER1>%, which is more than <PER2>%.\n",
	'operation_not_permitted' => "Operation not permitted",
	'opening_log_file' => 'Opening Log file',
	'opening_file_to_edit' => 'Opening file to edit ...',
	'opening_file_to_view' => 'Opening file to view ...',
	'operation_could_not_be_completed_reason' => 'Operation could not be completed. Reason: ',
	'operation_could_not_be_completed_please_try_again' => 'Operation could not be completed. Please try again.',
	'operation_cancelled_by_user'	=>	'Operation could not be completed. Reason: Operation cancelled by user',
	'operation_cancelled_due_to_cutoff' => "Operation could not be completed. Reason: Operation cancelled due to Cut off.",
#------------------------------------------------- P -------------------------------------------------#
	'permission_denied' => "Permission denied.",
	'password' => "password",
	'password_missing' => 'Password is missing.',
	'please_configure_your' => "Please configure your",
	'private_encryption_key' => "Private encryption key",
	'profile_name' => 'Profile Name',
	'proxy_server' => 'Proxy Server',
	'please_try_again' => 'Please try again',
	'passwords_do_not_match' => 'Username and Password not matching each other. Please try again.',
	'press_esc_q_and_enter_to_exit_vi_editor' => 'Press "Esc key" followed by ":wq!" and "Enter key" to exit from vi editor',
	'please_wait_title' => 'Please Wait',
	'please_enter_restore_from_location_continue' => 'Please enter Restore From Location to continue',
	'please_login_again' => 'Please login again',
	'please_login_account_using_login_and_try' => 'Please login to your $AppConfig::appType account using login.pl script and try again.',
	'please_provide_your_details_below' => "Dear User, Please provide your details below.",
	'press_enter_to_go_back_to_main_menu' => "Press enter to go back to main menu",
	'please_enter_restore_loc_cont' => 'Please enter Restore Location to continue',
	'please_provide_permission_try' => 'Please provide proper permission and try again',
	'provide_the_version_no_for_file' => 'Provide the Version No. for file',
	'path_not_found' => 'path not found',
	'please_check_internet_con_and_try' => 'Please check your internet connectivity and try again.',
	'please_cp_perl_from' => 'Please copy perl libraries from',
	'please_update'	=> 'Please run "edit_supported_files.pl" and follow the instructions to update.',
	#'periodic_archive_running' => "Periodic archive job is running",
	'periodic_cleanup_operation' => "Periodic Cleanup Operation",
	'periodic_cleanup'   => 'Periodic Cleanup',
	'press_keys_to_close_vi_editor' => 'Press "Esc key" followed by ":wq!" and "Enter key" to exit from editor.',
	'press_keys_to_quit_vi_editor' => 'Press "Esc key" followed by ":q!" and "Enter key" to exit from editor.',
	'press_keys_to_close_nano_editor' => 'Press "Ctrl+O" followed by "Ctrl+X" keys to save and exit from editor.',
	'press_keys_to_quit_nano_editor' => 'Press "Ctrl+X" keys to exit from editor.',
	'press_keys_to_close_ee_editor' => 'Press "Ctrl+[" keys and choose the option from menu to save & exit from editor.',
	'press_keys_to_quit_ee_editor' => 'Press "Ctrl+[" keys and choose the option from menu to exit from editor.',
	'press_keys_to_close_emacs_editor' => 'Press "Ctrl+x" followed by "Ctrl+s" keys to save file and press "Ctrl+x" followed by "Ctrl+c" keys to exit from editor.',
	'press_keys_to_quit_emacs_editor' => 'Press "Ctrl+x" followed by "Ctrl+c" keys to exit from editor.',
	'press_keys_to_close_ne_editor' => 'Press "Esc key" key and choose the option from menu to save & exit from editor.',
	'press_keys_to_quit_ne_editor' => 'Press "Esc key" key and choose the option from menu to exit from editor.',
	'press_keys_to_close_jed_editor' => 'Press "Ctrl+x" followed by "Ctrl+s" keys to save file and press "Ctrl+x" followed by "Ctrl+c" keys to exit from editor.',
	'press_keys_to_quit_jed_editor' => 'Press "Ctrl+x" followed by "Ctrl+c" keys to exit from editor.',
	'preparing_to_delete' => "Preparing to delete...",
	'preparing_file_list' => 	=>	'Preparing File list...',
	'password_should_be_at_least_3_20_characters' => 'Password should be at least 3 - 20 characters. Please try again.',
	'please_select_options_to_run_schedule_backup_job' => "Please select options to run Schedule Backup Job",
	'please_update_your_script_to_latest_version' => 'Update your script to 2.16 or above version. ',
#------------------------------------------------- R -------------------------------------------------#
	're_configure_your_account_freshly' => "Re-configure your account freshly",
	'restore_from_location' => "Restore from location",
	'retain_logs' => "Retain logs",
	'restore_location' => "Restore location",
	'restore_title' => 'Restore',
	'reason' => 'reason',
	'Reason' => 'Reason: ',
	'restore_a_specific_version_of_your_file' => 'Restore a specific version of your file',
	'restore_from_not_found_reconfigure_acc_sett' => 'Restore from location not found. Please logout and re-configure your account freshly using ___account_settings___ and try again.',
	'release_notes' => 'Release Notes',
	'reason_length_must_as_menctioned' => 'Reason: Length must be between 4 to 64 characters',
	'reason_child_process_launch_failed'	=>	'Reason: Child process launch failed.',
	'restore_start_time'	=>	'Restore Start Time: ',
	'restore_end_time'	=>	'Restore End Time: ',
	'restore_progress' => "Restore Progress\n===============        \n",
	'restore_loc_prompt' => 'Restore location change prompt',
#------------------------------------------------- S -------------------------------------------------#
	'select_the_job_from_the_above_list' => "\nSelect the job from the above list. ",
	'select_backupset_file_for_archive' => "Select backupset for archive: ",
	'stop_backup' => "Stop Backup",
	'stop_restore' => "Stop Restore",
	'stop_localbackup' => "Stop Express Backup",
	'stop_archive' => "Stop archive cleanup",
	'storage_used' => "Storage Used:",
	'select_an_option' => "Select an option",
	'select_from_existing_backup_locations' => "Select from existing Backup Locations",
	'set_your_encryption_key' => "Set your encryption key",
	'select_the_item_you_want_to_edit' => "Select the item which you want to edit",
	'scheduled_backup' => "Scheduled backup",
	'scheduled_restore' => "Scheduled restore",
	'successfully_reported_error' => 'Error report has been sent',
	'selected_date_range' => 'Selected date range',
	'select_option_to_view_logs_for' => 'Select option to view logs for',
	'start_date_or_end_date_not_greater' => 'Start date or end date should not be greater than current date',
	'start_date_should_not_greater_end' => 'Start Date should not be greater than end date',
	'select_restore_from_loc_list' => 'Select Restore From Location below',
	'select_op_for_backup_type' => 'Select option for Backup Type:',
	'scripts_updated_successfully' => 'Scripts updated successfully.',
	'scheduled_localbackup_running' => "Scheduled Express Backup Job is running",
	'scheduled_backup_set' => "Scheduled backupset",
	'start_time' => "Start Time: ",
	'summary' => "Summary: ",
	'scanning_files' => "Scanning files...",
	'success' => "Success",
	'select_mount_point' => 'Select the mount point you want to backup in, from the list mentioned below:',
	'status_file_doesnt_exists' => 'Status File doesn\'t exists',
	'setting_up_your_backup_location' => 'Setting up your backup location...',
	'service_dir_updated_successfully' => 'Service directory has been updated successfully to ',
	'scan_completed' => 'Scan Completed !!',
	'same_service_dir_path_has_been_selected' => 'Same service path has been selected again.',
	'setting_up_your_encryption_key' => "Setting up your encryption key...",
	'schedule_your_backup_job' => 'Schedule your Backup job',
	'scheduled_time' => 'Scheduled Time',
	'status' => 'Status',
	'scheduled_time_and_cut_off_time_should_have_minimum_5_minutes_of_difference' => 'Scheduled time and cut off time should have minimum 5 minutes of difference',
	'sat_u' => 'SAT',
	'sun_u' => 'SUN',
	'speed_test_file_created_successfully' => 'speedTestFile.txt created successfully.',
	'speed_test_result_via_speed_test_net' => 'Speed test result via speedtest.net:',
	'starting_backup' => 'Starting Backup...',

#------------------------------------------------- T -------------------------------------------------#
	'this_job_might_be_stopped_already' => "This job might be stopped already",
	'there_are_no_items_to_delete' => "There are no items to delete.",
	'total_files_in_your_backupset' => "Total files in your backup set: ",
	'total_files_listed_for_deletion' => "Total files listed for deletion: ",
	'ticket_number_if_any' => 'Trouble ticket number (if created already)',
	'total_quota' => 'Total Quota',
	'title_email_address' => "Email address",
	'tech_issue_comment_suggest' => 'Technical issues/comments/suggestions',
	'truncating_report_message_' => 'Truncating error message...',
	'ticket_number_only_alphanumerics' => 'Ticket number can have only alphanumeric characters',
	'ticket_number_between_5_30' => 'Ticket number must be between 5 to 30 characters',
	'terminating_your_title' => 'Terminating your',
	'tue_u' => 'TUE',
	'thu_u' => 'THU',
#------------------------------------------------- U -------------------------------------------------#
	'unable_to_cache_the_quota' => "Unable to cache the quota",
	'unable_to_execute_evs_binary' => "Unable to execute EVS binary\nPlease configure or re-configure your account using account_setting.pl",
	'unable_to_find_or_execute_evs_binary' => "Unable to find or execute EVS binary\nPlease configure or re-configure your account using account_setting.pl",
	'unable_to_find' => "Unable to find ",
	'unable_to_start_cleanup_operation' => "Unable to start cleanup operation. ", 
	'unable_to_retrieve_the_quota' => "Unable to retrieve the quota",
	'unable_to_display_progress_bar' => "Unable to start Progress bar display",
	'undefined_job_name' => 'Undefined job name',
	'username' => 'username',
	'used_space' => 'Used Space',
	'your_max_attempt_to_email' => "Your maximum attempt to enter Email ID has reached.",
	'unable_to_open_file' => 'unable to open file',
	'unable_to_connect' => 'Unable to connect',
	'unable_to_change_your' => 'Unable to change your',
	'proxy_details_updated_successfully' => 'Proxy details has been updated successfully.',
	'updated_successfully' => 'Updated successfully.',
	'user_config_backuplocation_not_found' => "Invalid Backup Location\nPlease edit your account details using account_setting.pl",
	'user_config_backuptype_not_found' => "Invalid Backup Type\nPlease edit your account details using account_setting.pl",
	'user_config_bwthrottle_not_found' => "Invalid Bandwidth Throttle value\nPlease edit your account details using account_setting.pl",
	'user_config_encryptiontype_not_found' => "Invalid Encryption Type\nPlease re-login to your account using login.pl",
	'user_config_restorefrom_not_found' => "Invalid Restore From\nPlease edit your account details using account_setting.pl",
	'user_config_restorelocation_not_found' => "Invalid Restore Location\nPlease edit your account details using account_setting.pl",
	'user_config_retainlogs_not_found' => "Invalid Retain Logs Value\nPlease edit your account details using account_setting.pl",
	'unable_to_create_cancel_file' => 'Unable to create cancel file',
	'unable_to_kill_job' => 'Unable to kill the job',
	'user_config_dedup_not_found' => "Invalid User Details\nPlease reconfigure your account using account_setting.pl",
	'user_config_username_not_found' => "Invalid Username\nPlease re-login to your account using login.pl",
	'user_config_serverroot_not_found' => "Invalid server root\nPlease re-login to your account using login.pl",
	'unable_to_find_mount_point' => 'Unable to find mount point. ',
	'unable_to_proceed'	=>	'Unable to proceed the operation.',
	'unable_to_proceed_backup' => 'Unable to proceed the backup operation. Reason: Child process launch failed for monitoring output file.',
	'unable_to_proceed_restore' => 'Unable to proceed the restore operation. Reason: Child process launch failed for monitoring output file.',	
	'unable_to_download_evs_binary' => "Unable to download EVS binary",
	'unable_to_open' => 'Unable to open',
	'update_device_name_failed_try_again_later' => 'Update device name failed. Try again later.',
	'updating_your_backup_to_device_name' => 'Updating your device name',
	'unable_to_login_please_try_login_script' => 'Unable to login. Please try login using login.pl.',
	'username_must_contain_4_20_characters' => 'Username must contain 4 - 20 characters. Please try again',
	'username_must_contain_4_characters' => 'Username must contain minimum 4 characters. Please try again',
	'username_should_contain_specific_characters' => 'Username should contain a-z, 0-9 and underscore',
	'user_directory_has_been_created_successfully' => 'User directory has been created successfully.',
	'updating_scripts_wait' => 'Updating scripts. Please wait',
	'update_failed_to_download' => 'Update failed. Reason: unable to download package.',
	'update_failed_unable_to_unzip' => 'Update failed, Reason: unable to unzip.',
	'upload_multiple_chunks' => 'Upload multiple file chunks simultaneously',
	'upload_multiple_chunks_enabled' => 'Upload multiple file chunks simultaneously is "Enabled".',
	'upload_multiple_chunks_disabled' => 'Upload multiple file chunks simultaneously is "Disabled".',
#------------------------------------------------- V -------------------------------------------------#	
	#'verifying_your_account_info'	=>	'Verifying your account information...',
	'view_logs_for_backup' => 'View logs for Backup',
	#'view_logs_for_scheduled_backup' => 'View logs for Scheduled Backup',
	'view_logs_for_express_backup' => 'View logs for Express Backup',
	'view_logs_for_restore' => 'View logs for Restore',
	'view_logs_for_archive' => 'View logs for Archive Cleanup',
	#'view_logs_for_periodic_cleanup' => 'View logs for Periodic Cleanup',
	'verifying_your_account_info' => "\nVerifying your account information... ",
	'verifying_your_encryption_key' => "Verifying your encryption key...",
	'verification_of_encryption_key_is_successfull' => 'Verification of encryption key is successful.',
	'view_scheduled_jobs' => 'View Scheduled Jobs',
#------------------------------------------------- W -------------------------------------------------#
	'want_to_change_username' => 'Do you want to change this username (y/n)?',
	'would_you_like_to_edit_yn' => 'Would you like to edit (y/n)?',
	'weekly_u' => 'WEEKLY',
	'wed_u' => 'WED',
	'with_cut_off_time_for' => 'with cut off time',
#------------------------------------------------- X -------------------------------------------------#
#------------------------------------------------- Y -------------------------------------------------#
	'you_can_stop_one_job_at_a_time' => "You can stop only one job at a time",
	'your_service_directory_is' => "Your service directory is: ",
	'your_backup_to_device_name_is' => 'Your Backup Location is set to',
	'your_restore_from_device_is_set_to' => 'Your restore from location is set to',
	'your_backup_location_is' => 'Your Backup Location is ',
	'your_backup_type_is' => 'Your Backup type is ',
	'your_restore_location_is_set_to' => "Your Restore Location is set to",
	'your_account_details_are' => "Your account details are",
	'your_max_attempt_reached' => 'Your maximum attempts reached. Please try again.',
	'your_max_attempt_reached_only' => 'Your maximum attempts reached.',
	'your', => 'your',
	'your_restore', => 'Your Restore',
	'your_max_attempt_restore_location_reached' => 'Your maximum attempt to change Restore from location has reached',
	'your_restore_from_loc_remains' => 'Your Restore from location remains',
	'your_restore_from_loc_changed_to' => 'Your Restore from location has been changed to ',
	'your_bw_value_set_to' => 'Your bandwidth throttle is set to ',
	'your_default_bw_value_set_to' => 'Your default bandwidth throttle is set to ',
	'your_retain_logs_is_enabled' => 'Your Retain Logs option is "Enabled".',
	'your_retain_logs_is_disabled' => 'Your Retain Logs option is "Disabled".',
	'your_backup_type_is_set_to' => 'Your Backup type is set to ',
	'your_backup_type_is_changed_to' => 'Your Backup type is changed to ',
	'your_account_is_not_configured_login_and_try_again' => 'Your account is not configured. Please configure using account_setting.pl and try again.',
	#'your_restore_from_device_to' => 'Your restore from location is set to ',
	'your_restore_location' => "Your Restore Location is set to ",
	'your_default_service_directory' => 'Considering your default service directory...',
	'your_max_attempt_to_email' => "Your maximum attempt to enter Email ID has reached.",
	'your_previous_mount_point' => "Your previous mount point is '<ARG>'. Do you want to edit (y/n)?",
	'your_selected_mount_point' => "Your selected mount point to backup your data is '<ARG>'.",
	'your_account_not_configured_properly' => 'Your account not configured properly. Please logout and re-configure your account freshly using account_setting.pl and try again.',
	'your_backupset_is_empty' => 'Your backupset is empty. No items to cleanup.',
	'you_have_selected_per_as_cleanup_limit' => "You have entered <PER>% as your cleanup limit.",
	'your_proxy_has_been_disabled' => "Your proxy has been \"Disabled\".",
	'your_hostname_is_empty' => 'Your hostname is empty. Please provide the hostname and try again.',
	'your_email_notification_settings_are' => 'Your email notification settings are',
	'your_backup_location_name_is' => 'Your backup location name is',
	'your_default_backup_file_created' => "Your default Backupset file has been created successfully.",
	'your_default_localbackup_file_created' => "Your default Express Backupset file has been created successfully.",
	'your_default_restore_file_created' => "Your default Restoreset file has been created successfully.",
	'your_default_scheduled_restore_file_created' => "Your default Schedule Restoreset file has been created successfully.",
	'your_default_full_exclude_file_created' => "Your default Full Exclude list file has been created successfully.",
	'your_default_partial_exclude_file_created' => "Your default Partial Exclude list file has been created successfully.",
	'your_default_regex_exclude_file_created' => "Your default Regex Exclude list file has been created successfully.",	
#------------------------------------------------- Z -------------------------------------------------#	
	'zipped_package_not_latest' => "Zipped package has version lower than current version. Do you really want to update (y/n)?",
);
1;
